import 'package:ref/ref.dart';
import 'package:ref_example/model/tour.dart';
import 'package:ref_example/model/user.dart';

class UserStore {
  // 用户信息
  var userInfo = Ref<UserModel>(UserModel.fromJson({}));
  // 游玩信息
  var tourInfo = Ref<TourModel>(TourModel.fromJson({}));

  UserStore();

  // 用户登陆
  loginIn(Map<String, String> json) {
    if (['', null].contains(json['userName']) ||
        ['', null].contains(json['nickName'])) {
      print('用户名和昵称不能为空');
      return;
    }
    userInfo.value = UserModel.fromJson(json);
  }

  // 用户登出
  loginOut() {
    userInfo.set(() {
      userInfo.value.loginOut();
    });
  }

  // 选择某一个游玩信息
  choiceTour(TourModel info) {
    tourInfo.value = info;
  }

  // 删除某一个游玩信息
  deleteTour() {
    tourInfo.value = TourModel.fromJson({});
  }
}
