import 'package:ref/ref.dart';
import 'package:ref_example/model/tour.dart';

// 模拟数据
List<Map<String, dynamic>> _tempList = [
  {
    'id': '0001',
    'title': '豪华1日游',
    'price': 250,
    'desc': '去深圳湾看海鸟，去看浩瀚无垠的大海，美哉！！！'
  },
  {
    'id': '0002',
    'title': '豪华3日游',
    'price': 3999,
    'desc': '海南的天涯海角，去看日出日落，观音大佛，坐游艇哦！！！'
  },
  {
    'id': '0003',
    'title': '豪华8日游',
    'price': 49999,
    'desc': '你想一夜之间成为土豪吗，你想去迪拜第一高楼吃土吗！！！'
  },
];

class TourStore {
  // 用户信息
  var tourList = Ref<List<TourModel>>([]);

  TourStore();

  // 请求用户数据
  requestList() {
    Future.delayed(Duration(milliseconds: 2000), () {
      List<Map<String, dynamic>> tempList = _tempList;
      tourList.value.clear();
      tourList.set(() {
        tempList.forEach((ele) {
          tourList.value.add(TourModel.fromJson(ele));
        });
      });
    });
  }

  // 获取旅游列表
  Ref<List<TourModel>> getTourList() {
    if (tourList.value.length == 0) requestList();
    return tourList;
  }
}
